//<?php
/**
 * dwtinc
 * 
 * <strong>0.2</strong> Include Dreamweaver template file.
 *
 * @category 	snippet
 * @version 	0.2
 * @license 	http://www.gnu.org/copyleft/gpl.html GNU Public License (GPL)
 * @internal	@properties 
 * @internal	@modx_category Manager and Admin
 */

/* Setting */
if(empty($title)) $title = '[*pagetitle*]|[(site_name)]';

/* Ready */
if(strpos($file, '/') === 0)
{
	$file = preg_replace('@^' . MODX_BASE_URL . '@', MODX_BASE_PATH, $file);
}
elseif(strpos($file, '/')===false && strpos($file, '.dwt')!==false)
{
	$search_dir = MODX_BASE_PATH . 'Templates/';
	$file = $search_dir . $file;
}
else
{
	$search_dir = MODX_BASE_PATH . 'assets/templates/';
	$file = $search_dir . $file;
}
if(!file_exists($file)) return 'Template not found.';
if(strpos($file, '.dwt')!==false) $mode = 'dwt_relative';

$tv_pattern = '<!-- [a-zA-Z]+?BeginEditable.+?name="(.+?)".+?[a-zA-Z]+?EndEditable[^>]+>';
$tv_pattern = '@' . $tv_pattern . '@ms';
$cnk_pattern = '<!-- #BeginLibraryItem "/Library/(.+?)\.lbi".+?<!-- #EndLibraryItem[^>]+?>';
$cnk_pattern = '@' . $cnk_pattern . '@ms';

/* Main */
$tplfile = file_get_contents($file);

$tplfile = mb_convert_encoding($tplfile, $modx->config['modx_charset'], 'UTF-8,SJIS,EUC-JP,ASCII');
$pattern = '/(<meta[^>]+charset\s*=+)[^>"\'=]+(.+>)/i';
$replace = '$1' . $modx->config['modx_charset'] . '$2';
$tplfile = preg_replace($pattern, $replace, $tplfile);

$tplfile = preg_replace($tv_pattern, "[*$1*]", $tplfile);
$tplfile = str_replace('[*doctitle*]', '<title>' . $title . '</title>', $tplfile);
$tplfile = preg_replace($cnk_pattern, '{{' . "$1" . '}}', $tplfile);
if($mode=='dwt_relative')
{
	$tplfile = str_replace('src="../', 'src="' . MODX_BASE_URL, $tplfile);
	$tplfile = str_replace('href="../', 'href="' . MODX_BASE_URL, $tplfile);
}

return $tplfile;
